Package: org.gradle.testing.jacoco.tasks

## [Groovy] Class JacocoReport

- org.gradle.testing.jacoco.tasks.JacocoReport

- All Implemented Interfaces and Traits:
    Reporting

      @Incubating
      class JacocoReport
      extends JacocoBase

  Task to generate HTML, Xml and CSV reports of Jacoco coverage data.

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `FileCollection` | `additionalClassDirs` Additional class dirs that coverage data should be reported for.
    `FileCollection` | `additionalSourceDirs` Additional source dirs for the classes coverage data is being reported for.
    `FileCollection` | `classDirectories` Source sets that coverage should be reported for.
    `FileCollection` | `executionData` Collection of execution data files to analyze.
    `FileCollection` | `sourceDirectories` Source sets that coverage should be reported for.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `JacocoReport ()`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `additionalClassDirs(File... dirs)` Adds additional class directories to those that will be included in the report.
    `void` | `additionalClassDirs(FileCollection dirs)` Adds additional class directories to those that will be included in the report.
    `void` | `additionalSourceDirs(File... dirs)` Adds additional source directories to be used for any classes included in the report.
    `void` | `additionalSourceDirs(FileCollection dirs)` Adds additional source directories to be used for any classes included in the report.
    `void` | `executionData(Object... files)` Adds execution data files to be used during coverage analysis.
    `void` | `executionData(Task... tasks)` Adds execution data generated by a task to the list of those used during coverage analysis.
    `void` | `executionData(TaskCollection tasks)` Adds execution data generated by the given tasks to the list of those used during coverage analysis.
    `void` | `generate()`
    `FileCollection` | `getAllClassDirs()` Gets the class directories that coverage will be reported for.
    `FileCollection` | `getAllSourceDirs()` Gets the source directories for the classes that will be reported on.
    `protected IsolatedAntBuilder` | `getAntBuilder()`
    `protected Instantiator` | `getInstantiator()`
    `JacocoReportsContainer` | `getReports()` Returns the reports to be generated by this task.
    `JacocoReportsContainer` | `reports(Closure closure)` Configures the reports to be generated by this task.
    `void` | `sourceSets(SourceSet... sourceSets)` Adds a source set to the list to be reported on.

- - ### Property Detail

    - #### @Optional @InputFiles FileCollection additionalClassDirs

      Additional class dirs that coverage data should be reported for.

    - #### @Optional @InputFiles FileCollection additionalSourceDirs

      Additional source dirs for the classes coverage data is being reported for.

    - #### @InputFiles FileCollection classDirectories

      Source sets that coverage should be reported for.

    - #### @InputFiles FileCollection executionData

      Collection of execution data files to analyze.

    - #### @InputFiles FileCollection sourceDirectories

      Source sets that coverage should be reported for.

  - ### Constructor Detail

    - #### JacocoReport()

  - ### Method Detail

    - #### void additionalClassDirs(File... dirs)

      Adds additional class directories to those that will be included in the report.

      Parameters:
        `dirs` - one or more directories containing classes to report coverage of

    - #### void additionalClassDirs(FileCollection dirs)

      Adds additional class directories to those that will be included in the report.

      Parameters:
        `dirs` - a `FileCollection` of directories containing classes to report coverage of

    - #### void additionalSourceDirs(File... dirs)

      Adds additional source directories to be used for any classes included in the report.

      Parameters:
        `dirs` - one or more directories containing source files for the classes included in the report

    - #### void additionalSourceDirs(FileCollection dirs)

      Adds additional source directories to be used for any classes included in the report.

      Parameters:
        `dirs` - a `FileCollection` of directories containing source files for the classes included in the report

    - #### void executionData(Object... files)

      Adds execution data files to be used during coverage analysis.

      Parameters:
        `files` - one or more files to add

    - #### void executionData(Task... tasks)

      Adds execution data generated by a task to the list of those used during coverage analysis. Only tasks with a JacocoTaskExtension will be included; all others will be ignored.

      Parameters:
        `tasks` - one or more tasks to add

    - #### void executionData(TaskCollection tasks)

      Adds execution data generated by the given tasks to the list of those used during coverage analysis. Only tasks with a JacocoTaskExtension will be included; all others will be ignored.

      Parameters:
        `tasks` - one or more tasks to add

    - #### @TaskAction void generate()

    - #### FileCollection getAllClassDirs()

      Gets the class directories that coverage will be reported for. All classes in these directories will be included in the report.

      Returns:
        class dirs to report coverage of

    - #### FileCollection getAllSourceDirs()

      Gets the source directories for the classes that will be reported on. Source will be obtained from these directories only for the classes included in the report.

      Returns:
        source directories for the classes reported on
      See Also:
        getAllClassDirs()

    - #### @Inject protected IsolatedAntBuilder getAntBuilder()

    - #### @Inject protected Instantiator getInstantiator()

    - #### JacocoReportsContainer getReports()

      Returns the reports to be generated by this task.

    - #### JacocoReportsContainer reports(Closure closure)

      Configures the reports to be generated by this task.

    - #### void sourceSets(SourceSet... sourceSets)

      Adds a source set to the list to be reported on. The output of this source set will be used as classes to include in the report. The source for this source set will be used for any classes included in the report.

      Parameters:
        `sourceSets` - one or more source sets to report on